#! /bin/sh
#procedure to partition disks and mount osukiss
#$[1-*] list of disk to be repartionned
#----------------------------------------------
. `dirname $0`/conf.sh
. `dirname $0`/manage.sh
#----------------------------------------------
setdevice ()

{
#Dismantling possible raid array
for dsk in ${1}* 
  do
  if [ "$dsk" = "$1" ] ; then
    continue
    fi
  ru=`echo $dsk | cut -d '/' -f3`
  raid=`cat /proc/mdstat | grep $ru | cut -d ' ' -f1`
  if [ -n "$raid" ] ; then
    mdadm -S /dev/$raid > /dev/null 2>&1
    fi
  done
echo "Partitioning $1"
for p in 1 2 3 4 5 6 7 8 9 
  do
  if [ -b ${1}$p ] ; then
    wipefs -a -q ${1}$p
    fi
  done
dd if=/dev/zero of=$1 bs=512 conv=notrunc count=10000 > /dev/null 2>&1
if [ -n "$2" ] ; then
  sfdisk -q -W always -w always $1 < `dirname $0`/raidpart
  else
  sfdisk -q -W always -w always $1 < `dirname $0`/diskpart
  fi
if [ $? -ne 0 ] ; then
 aborting "Unable to create $1 partition"
 fi
#setting up an hybride partition of disk
cat `dirname $0`/diskhyb | gdisk $1 > /dev/null 2>&1
}
#----------------------------------------------
clear  
if [ $# -eq 0 ] ; then
  aborting "Need at least one disk to be assigned"
  fi
echo "Installation... Partitioning in progress, please wait..."
sleep 1
if [ $# -gt 1 ] ; then
  raidmode="raid"
  fi
if [ $# -gt 0 ] ; then
  `dirname $0`/calpart.sh $1
  for device in $*
    do
    setdevice $device $raidmode
    done
  fi
if [ -n "$raidmode" ] ; then
  for part in 1 2 3 4
    do
    case "$part" in
      "1"	)
        raidtype="1 -e 0.90"
        ;;
      "2"	)
        raidtype="0 -c 4096K"
        ;;
      "4"	|	\
      "3"	)
        raidtype="10 -p o2 -c 2048K"
        ;;
      esac
    dsk=""
    if [ -b /dev/md$part ] ; then
      mdadm -S -q /dev/md$part
      fi
    for device in $*
      do
      mdadm -q --zero-superblock $device$part
      #to clean previous partition information
      dd if=/dev/zero of=$device$part count=100 bs=1k > /dev/null 2>&1
      dsk="$dsk $device$part"
      done
    mdadm -q -C --assume-clean -n $# -l $raidtype  /dev/md$part $dsk 
    mdadm -q -G -b internal --bitmap-chunk=262144 /dev/md$part
    done
  fi
tomount=$1
if [ $# -gt 1 ] ; then
  tomount=/dev/md	
  fi
. `dirname $0`/setformat.sh ${tomount}1,ext4 ${tomount}3,ext4 ${tomount}4,ext4
. `dirname $0`/setformat.sh ${tomount}2,swap
. `dirname $0`/setmount.sh ${tomount}3,/ ${tomount}1,boot ${tomount}4,extension
. `dirname $0`/setmdadm.sh $MOUNTPOINT
. `dirname $0`/setformat.sh ${1}5,vfat 
. `dirname $0`/setmount.sh ${1}5,boot/efi
#----------------------------------------------------------
#final adjustments
mkdir -p $MOUNTPOINT/etc
echo "Setting \"`uname -n`\" as host name"
uname -n > $MOUNTPOINT/etc/hostname
echo "Setting resolv file"
cp -a /etc/resolv.conf $MOUNTPOINT/etc
#----------------------------------------------------------
#adding swap partition
echo "activating swap"
swapon ${tomount}2
#----------------------------------------------------------
sleep 5

