#! /bin/sh
#----------------------------------------------------------------
#Procedure to report disk within system
#$1 minimal disk size requested in GigaBytes
#----------------------------------------------------------------
#minimal disk size in GigaBytes
MINDSKSIZE=$1
#Search for disk devices
DRANGE='a b c d e f g h i j k l m n o p r s t u v w'

#----------------------------------------------------------------
found_disk="bad"

for disk in `ls /dev/[s,v]d[a-z]`
  do
  if [ -b $disk ] ; then
    devGsize=`echo "\`blockdev --getsize64 $disk\` / (1024*1024*1024)"| bc`
    if [ $devGsize -gt $MINDSKSIZE ] ; then
      model=`smartctl -a $disk | grep "Device Model:" | cut -d ':' -f2 | tr -s ' '`
      capacity=`smartctl -a $disk | grep "User Capacity:" | cut -d '[' -f2 | cut -d ']' -f1 | tr -s ' '`
      serial=`smartctl -a $disk | grep "Serial Number:" | cut -d ':' -f2 | tr -s ' '`
      echo -e "\"$disk\"" "\"$capacity $serial $model\" \"Off\""
      found_disk="OK"
      fi
    fi
  done
