#! /bin/sh
#----------------------------------------------
#to install released package on the system
#$1 version release number
#$2 mount point
#----------------------------------------------
#setting configuration context
. `dirname $0`/conf.sh
. `dirname $0`/manage.sh
#----------------------------------------------
TMPNAME=/tmp/`basename $0`-$$
if [ -n "$1" ] ; then
  RELEASEVER=$1 
  fi
if [ -n "$2" ] ; then
  MOUNTPOINT=$2 
  fi
#----------------------------------------------
#Preparing RPM database
#$1 mountpoint
preprpm()

{
rpm --root=$1 --initdb
rpm --root=$1 --rebuilddb
}
#----------------------------------------------
#to prepare mounted area to chrooted

prepsys()

{
#checking if all needed devices are here
for needed in proc sys dev
  do
  if [ ! -d  $MOUNTPOINT/$needed ] ; then
    mkdir -p $MOUNTPOINT/$needed
    fi
  mount -o bind /$needed $MOUNTPOINT/$needed
  done
mkdir -p $MOUNTPOINT/run
mount -t tmpfs tmpfs $MOUNTPOINT/run

#preparing system
mkdir $MOUNTPOINT/tmp
chmod 1777 $MOUNTPOINT/tmp

#preparing zypp working file
mkdir -p $MOUNTPOINT/etc/zypp
mkdir -p $MOUNTPOINT/tmp/zypp
cp -a /etc/zypp/repos.d $MOUNTPOINT/etc/zypp
cp -a `dirname $0`/../repoloc $MOUNTPOINT

echo "Preparing Zypper"
preprpm $MOUNTPOINT
zypper						\
	--releasever=$RELEASEVER		\
	--installroot=$MOUNTPOINT		\
	refresh
echo "Zypper Ready"

}
#----------------------------------------------
(
PACKAGES="release-base release-server release-devel release-desktop-hardware release-desktop-virtual"
for pack in $PACKAGES
  do
  echo -e "\"$pack\" \"\" \"Off\""
  done 
) | tr '\n' ' ' > $TMPNAME
exec 3>&1;
packages=$(dialog				\
        --title "Selecting System packages"	\
        --checklist "$MENU" 0 80 0		\
        --file $TMPNAME				\
        2>&1 1>&3);
  retval=$?
  exec 3>&-;
  if [ $retval != 0 ] ; then
    exit 1              #trouble trouble
    fi
rm -fr $TMPNAME

#to remove '"" charactere
packages=`echo $packages | tr -d '"'`
clear
if [ -n "$packages" ] ; then
  echo "Starting Installation, Please wait for completion"
  prepsys
  sleep 1
  zypper clean
  zypper 					\
	--releasever=$RELEASEVER		\
	refresh
  zypper					\
	-n					\
	-C $MOUNTPOINT/tmp/zypp			\
	--releasever=$RELEASEVER		\
	--installroot=$MOUNTPOINT		\
	install					\
	$packages
  if [ $? = 0 ] ; then
    chroot $MOUNTPOINT rpm --initdb
    echo "Packages Installation successfully completed"
    echo "Press \"Enter\" to continue"
    read typed
  else
    aborting "Unable to do package installation"
  fi
else
  aborting "Package list was empty"
fi
