#! /bin/sh
#----------------------------------------------
#procedure to format disk partitions
#Parameter, lits of partition with format type
#----------------------------------------------
. `dirname $0`/conf.sh
. `dirname $0`/manage.sh
#----------------------------------------------
LAB=`date +%s`
while [ -n "$1" ] ; do 
  disk=`echo $1 | cut -d ',' -f1`
  ftype=`echo $1 | cut -d ',' -f2`
  part=`echo $disk | cut -d '/' -f3`
  wipefs -a -q $disk
  echo  "($disk,$ftype) Partition formating in progress..."
  case $ftype in
    "vfat"	)
      mkfs.vfat -n ${part^^}_${LAB:5:5} $disk > /dev/null 2>&1
      ;;
    "ext2"	|					\
    "ext4"	)
      mke2fs -F -t $ftype -q -L "${part}_${LAB}" -j $disk
      ;;
    "swap"	)
      mkswap -L "${part}_${LAB}" $disk > /dev/null
      ;;
    *		)
      aborting "Unexpected formtype \"$ftype\" for partition \"$disk\""
      ;;
    esac
  shift;
  continue
  done
echo "Formating Completed"

