#! /bin/sh
#----------------------------------------------
#$1 MOUNTPOINT
#----------------------------------------------
#script to generate fstab contents
MOUNTPOINT=$1

if [ -n "$MOUNTPOINT" ] ; then
  mkdir -p $MOUNTPOINT/etc
  (
  echo -e "#-------------------------------------------------"
  echo -e "#done by installer `date`"
  echo -e "#-------------------------------------------------"
  ) > $MOUNTPOINT/etc/fstab
  for part in `df | grep $MOUNTPOINT | grep  ^/dev | cut -d ' ' -f1`
    do
    label=`blkid -o export $part | grep "^LABEL="`
    type=`blkid -o export $part | grep "TYPE=" | head -1 | cut -d '=' -f2`
    mnt=`df | grep $part | tr -s ' ' | cut -d ' ' -f6 | \
	      sed -e "s:$MOUNTPOINT::"`
    (
    seq="${mnt//[^\/]}"
    pos=`(echo ${#seq} + 1)|bc`
    mnt=`echo $mnt | sed -e "s:^/::"`
    echo -e "$label\t/$mnt\t\t$type\tdefaults\t1 ${pos}"
    ) >> $MOUNTPOINT/etc/fstab
    done
  for swpd in `swapon -s | grep partition | cut -d ' ' -f1`
    do
    label=`blkid $swpd | cut -d ' ' -f2`
    (
    echo -e "$label\tswap\t\tswap\tdefaults\t0 0"
    ) >> $MOUNTPOINT/etc/fstab
    done
  (
  echo -e "#-------------------------------------------------"
  echo -e "devpts\t\t\t/dev/pts\tdevpts\tgid=5,mode=620\t0 0"
  echo -e "sysfs\t\t\t/sys\t\tsysfs\tdefaults\\t0 0"
  echo -e "proc\t\t\t/proc\t\tproc\tdefaults\\t0 0"
  echo -e "#-------------------------------------------------"
  ) >> $MOUNTPOINT/etc/fstab
  echo "Fstab file created"
  fi
