#! /bin/sh
#----------------------------------------------
#procedure to configure grub on the freshly
#installe Osukiss
#----------------------------------------------
#$1 is the mountpoint
#$2 is the installation device(s)
#----------------------------------------------
. `dirname $0`/conf.sh
. `dirname $0`/manage.sh
SEPA="#--------------------------------------------------------------------------------"
#----------------------------------------------
if [ -z "$1" -o -z "$2" ] ; then
  echo "$0 need a MOUNTPOINT and at least one DEVICE as parameters"
  exit 1
  fi
MOUNTPOINT=$1
shift
DEVICE=$1
#----------------------------------------------
echo "Starting grub configuration installation on $MOUNTPOINT"
sleep 2

> $MOUNTPOINT/boot/grub/device.map
chroot $MOUNTPOINT grub-mkconfig -o /boot/grub/grub.cfg

(
echo "$SEPA" 
echo "#this device map was generated by \"installer\" script,  `date`" 
echo "$SEPA" 
) > /tmp/device.map

num=0
for dsk in $* 
  do
  byid=`udevadm info --name=$dsk --query=property | grep DEVLINK | cut -d '=' -f2`
  echo -e "(hd$num)\t$byid" >> /tmp/device.map
  echo "Starting grub boot installation on device \"$dsk\""
  chroot $MOUNTPOINT						\
	  	grub-install					\
	  	--target=i386-pc 				\
	  	$dsk
  chroot $MOUNTPOINT						\
	  	grub-install					\
	  	--target=x86_64-efi 				\
		--efi-directory=/boot/efi 			\
		--bootloader-id=BOOT				\
		--recheck					\
		$dsk
  chroot $MOUNTPOINT 						\
	  cp 							\
	  	/boot/efi/EFI/BOOT/grubx64.efi			\
	  	/boot/efi/EFI/BOOT/BOOTX64.EFI
  num=`echo $num + 1 | bc`
  done
cp -f /tmp/device.map $MOUNTPOINT/boot/grub/device.map
sleep 1
echo "Grub boot installation completed"
echo "Press \"Enter\" to continue"
read typed
