#! /bin/sh
#----------------------------------------------------------------
#Procedure to initialize system
#----------------------------------------------------------------
PATH=$PATH:`dirname $0`
#----------------------------------------------------------------
TMPNAME=/tmp/startup-$$
DISKSIZE=50             #Minimal Disk size in Gigabytes
#----------------------------------------------------------------
#setting the terminal TYPE
. `dirname $0`/conf.sh
. `dirname $0`/manage.sh
TOGO=1
#----------------------------------------------------------------
while [ "$TOGO" = "1" ] ;
  do
  for action in Keys Inst Shell Shutdown
    do
    case "$action" in
      "Keys"	)  explain="Set System keyboard";;
      "Inst"	)  explain="Install system"	;;
      "Shell"	)  explain="Rescue system"	;;
      "Shutdown")  explain="Poweroff system"	;;
      "*"	)			;;
      esac
    echo "\"$action\" \"($explain)\""
    done | tr '\n' ' ' > $TMPNAME
#----------------------------------------------------------
#selecting the keyboard entry
  exec 3>&1;
  result=$(dialog				\
	--aspect 10				\
	--default-item "keys"			\
	--no-cancel				\
	--menu "$MENU" 0 45 0			\
	--file $TMPNAME				\
	2>&1 1>&3);

  exec 3>&-;
  if [ $? != 0 ] ; then
    exit 1		#trouble trouble
    fi
#removing intermediate file and exiting
rm -fr $TMPNAME
#----------------------------------------------------------
#setting Language
  case "$result" in
      "Keys"		)  getkbdlayout.sh		;;
      "Inst"		)  exec setsys.sh $DISKSIZE	;; 
      "Shell"		)  goshell			;;
      "Shutdown"	)  TOGO=0			;;
      "*"		)				;;
      esac
#----------------------------------------------------------
  done
clear
if [ `id -u` = 0 ] ; then
  echo "Shuting down system"
  sleep 2
  poweroff
  fi
exit 0
 
